﻿using Infragistics.Documents.Excel;
using Infragistics.Documents.Excel.Charts;
using Microsoft.Win32;
using System.Data;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ExcelTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Test();
        }


        private void Test()
        {
            DataTable tbl = new();
            tbl.Columns.Add("x", typeof(string));
            tbl.Columns.Add("y", typeof(double));


            DataRow row;
            for (int i = 0; i < 10; i++)
            {
                row = tbl.NewRow();
                row[0] = (i / 10.0).ToString();
                row[1] = 1.01;      // DOES NOT WORK (double)
                //row[1] = 1;       // WORKS (int)
                tbl.Rows.Add(row);
            }


            Workbook workbook = new Workbook(WorkbookFormat.Excel2007);
            Worksheet sheet = workbook.Worksheets.Add("Sheet1");

            for (int i = 0; i < 10; i++)
            {
                WorksheetRow sheetRow = sheet.Rows[i+2];
                sheetRow.Cells[0].Value = tbl.Rows[i]["x"];
                sheetRow.Cells[1].Value = tbl.Rows[i]["y"];
            }

            WorksheetRow rowWs = sheet.Rows[0];
            rowWs.Height = 5000;

            WorksheetCell cell1 = sheet.GetCell("A1");
            WorksheetCell cell2 = sheet.GetCell("M1");

            WorksheetChart chart = sheet.Shapes.AddChart(ChartType.Line, cell1, new Point(0, 0), cell2, new Point(100, 100));
            chart.SetSourceData("A3:B12", false);
            chart.ChartTitle = new ChartTitle() { Text = new FormattedString("_xXx_") };

            workbook.Save(@"D:\test.xlsx");
        }
    }
}